Attribute VB_Name = "Contracts"
Option Compare Database
Option Explicit


Sub GenerateContract()

'declare the vars
Dim currentID As Long
Dim contractPath As String
Dim contractDoc As String
Dim contractPathDoc As String
Dim contractAdd1PathDoc, contractAdd2PathDoc, contractAdd3PathDoc, contractAdd4PathDoc As String
Dim templatePath As String
Dim templateDoc As String
Dim templateAdd1, templateAdd2, templateAdd3, templateAdd4, templateEmpty As String
Dim templatePathDoc As String
Dim language As String
Dim docDate As Date
Dim Country As String
Dim txtDurationClause As String
Dim txtType As String
Dim txtRegime As String
Dim objCC As ContentControl
Dim txtTemp As String

' recordset vars
Dim db As DAO.Database
Dim strSql As String
Dim strSql2 As String
Dim counter As Byte
Dim nrRows As Integer
Dim rsContracts As DAO.Recordset
Dim rsEntityTexts As DAO.Recordset

'Word vars
Dim objWord As Word.Application
Dim heading(2) As String
Dim i As Byte

'masterdoc vars
Dim answer As Byte
Dim rng As Range
Dim strFile 'As String
Dim Count As Long


'errors
'On Error GoTo errorHandling

'------
'setup
'------
'ensure latest changes saved and all is ok to go
DoCmd.RunCommand acCmdSaveRecord

'recordsets for contracts and texts
    currentID = Screen.ActiveForm.txtContractID
    Set db = CurrentDb()
    strSql = "SELECT * from qryContracts where ContractID = " & currentID
    Set rsContracts = db.OpenRecordset(strSql, dbOpenDynaset, dbSeeChanges)
'    strSql2 = "SELECT * from tblEntityTexts where ContractID = " & Screen.ActiveForm.txtContractID & _
'                " AND textLanguage = " & "'" & Screen.ActiveForm.cboContrLanguage & "'"
'    Set rsEntityTexts = db.OpenRecordset(strSql2, dbOpenDynaset, dbSeeChanges)
   

'initial vars
language = rsContracts![contrLanguage]
Country = rsContracts![entCountry]
docDate = Nz(rsContracts![contrCreationDate], Date)
templatePath = DLookup("configValue", "Configurations", "configLabel= " & "'" & "templatePath" & "'")
templateDoc = DLookup("configValue", "Configurations", "configLabel= " & "'" & "template" & Country & "-" & language & "'")
templateAdd1 = IIf(rsContracts![contrAddendExpat] = True, DLookup("configValue", "Configurations", "configLabel= " & "'" & "templateAdd1" & Country & "-" & language & "'"), "")
templateAdd2 = IIf(rsContracts![contrAddendGenzMgr] = True, DLookup("configValue", "Configurations", "configLabel= " & "'" & "templateAdd2" & Country & "-" & language & "'"), "")
templateAdd3 = IIf(rsContracts![contrAddendMAsector] = True, DLookup("configValue", "Configurations", "configLabel= " & "'" & "templateAdd3" & Country & "-" & language & "'"), "")
templateAdd4 = IIf(rsContracts![contrAddendTelework] = True, DLookup("configValue", "Configurations", "configLabel= " & "'" & "templateAdd4" & Country & "-" & language & "'"), "")
templateEmpty = DLookup("configValue", "Configurations", "configLabel= " & "'" & "templateEmpty" & "'")
contractPath = DLookup("configValue", "Configurations", "configLabel= " & "'" & "docPath" & "'")
contractDoc = "Contract" & Country & rsContracts![Name] & Year(docDate) & Format(docDate, "mm") & Format(docDate, "dd")

'set the docs before launch, check if template is really available
    If Len(templateDoc) > 0 Then
        templatePathDoc = templatePath & IIf(Right(templatePath, 1) <> "\", "\", "") & templateDoc
        contractPathDoc = contractPath & IIf(Right(templatePath, 1) <> "\", "\", "") & contractDoc
    Else
        MsgBox "There's a problem with the base template, please check it's availability", vbOKOnly, "Template not found"
        Exit Sub
    End If
    

Application.Echo False
DoCmd.SetWarnings False
DoCmd.Hourglass True

'special expressions used in merge process
Select Case language
    Case "NL"
        txtDurationClause = IIf(rsContracts![contrType] = 1, " van " & rsContracts![contrFromDate] & _
                    " tot " & rsContracts![contrToDate], " en gaat in op " & rsContracts![contrFromDate])
        txtType = rsContracts![typeNL]
        txtRegime = rsContracts![regimeNL]
    Case "FR"
        txtDurationClause = IIf(rsContracts![contrType] = 1, " de " & rsContracts![contrFromDate] & _
                    "  " & rsContracts![contrToDate], " et commence le " & rsContracts![contrFromDate])
        txtType = rsContracts![typeFR]
        txtRegime = rsContracts![regimeFR]
    Case Else
        txtDurationClause = IIf(rsContracts![contrType] = 1, " from " & rsContracts![contrFromDate] & _
                    " till " & rsContracts![contrToDate], " and starts on " & rsContracts![contrFromDate])
        txtType = rsContracts![typeEN]
        txtRegime = rsContracts![regimeEN]
End Select
        
       

'--------------------------------
'Merge processing - main contract
'--------------------------------

'creatre the word doc
    Set objWord = CreateObject("Word.Application")
    With objWord
       .Visible = True
       .Documents.Add (templatePathDoc)
    End With

'general section
General:
            
    With objWord.ActiveDocument
    
'main contract data
        .SelectContentControlsByTag("ccDuration").Item(1).Range.Text = UCase(Nz(txtType, ""))
        .SelectContentControlsByTag("ccEntity").Item(1).Range.Text = DLookup("entContractRepresentor", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccEmployee").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccEmployeeLocation").Item(1).Range.Text = Nz(rsContracts![Street], "") & ", " & Nz(rsContracts![PostalCode], "") & " " & _
                                    Nz(rsContracts![City], "") & ", " & Nz(rsContracts![Country], "")
        .SelectContentControlsByTag("ccFunction").Item(1).Range.Text = Nz(LCase(rsContracts![contrFunction]), "")
        .SelectContentControlsByTag("ccDuration2").Item(1).Range.Text = Nz(txtType, "")
        .SelectContentControlsByTag("ccDurationClause").Item(1).Range.Text = Nz(txtDurationClause, "")
        If rsContracts![contrWorkPermitConstraints] = True Then
            .SelectContentControlsByTag("ccWorkpermitCancel").Item(1).Range.Text = _
                Replace(DLookup("WorkpermitCancel", "qryEntityTexts", "ContractID = " & currentID), "<date>", CStr(rsContracts![contrWorkPermitDate]))
        Else
            .SelectContentControlsByTag("ccWorkpermitCancel").Item(1).Range.Delete
            .SelectContentControlsByTag("ccWorkpermitCancel").Item(1).Delete True
        End If
'regime
        .SelectContentControlsByTag("ccRegime").Item(1).Range.Text = Nz(txtRegime, "")
        .SelectContentControlsByTag("ccHoursByWeek").Item(1).Range.Text = Nz(rsContracts![contrWorkhoursByWeek], 38)
        If rsContracts![contrRegime] = 2 Then
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text, "<Mon>", rsContracts![contrWorkMon])
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text, "<Tue>", rsContracts![contrWorkTue])
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text, "<Wed>", rsContracts![contrWorkWed])
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text, "<Thu>", rsContracts![contrWorkThu])
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Text, "<Fri>", rsContracts![contrWorkFri])
        Else
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Range.Delete
            .SelectContentControlsByTag("ccParttimeRegime").Item(1).Delete True
        End If
'salary
        .SelectContentControlsByTag("ccSalMonthly").Item(1).Range.Text = Nz(rsContracts![contrSalBrutoMonthly], "")
        .SelectContentControlsByTag("ccSalYearly").Item(1).Range.Text = Nz(rsContracts![contrSalBrutoMonthly], "")
        .SelectContentControlsByTag("cc13month").Item(1).Range.Text = DLookup("DoubleHoliPrime", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccPension").Item(1).Range.Text = DLookup("PensionHospi", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccMealTickets").Item(1).Range.Text = DLookup("LunchTicket", "qryEntityTexts", "ContractID = " & currentID)
        If rsContracts![contrTransportCost] = True Then
            .SelectContentControlsByTag("ccTransport").Item(1).Range.Text = DLookup("TransportCosts", "qryEntityTexts", "ContractID = " & currentID)
        Else
            .SelectContentControlsByTag("ccTransport").Item(1).Range.Delete
            .SelectContentControlsByTag("ccTransport").Item(1).Delete True
        End If
'Benefits
        If rsContracts![contrVariantSalary] = "IVR" Then
            .SelectContentControlsByTag("ccIVR").Item(1).Range.Text = _
                    Replace(DLookup("VariableRemunPerc", "qryEntityTexts", "ContractID = " & currentID), "<percent>", CStr(rsContracts![contrVariantIVR]))
            .SelectContentControlsByTag("ccMAprime").Item(1).Range.Delete
            .SelectContentControlsByTag("ccMAprime").Item(1).Delete True
        ElseIf rsContracts![contrVariantSalary] = "MA" Then
            .SelectContentControlsByTag("ccIVR").Item(1).Range.Delete
            .SelectContentControlsByTag("ccIVR").Item(1).Delete True
            .SelectContentControlsByTag("ccMAprime").Item(1).Range.Text = _
                    Replace(DLookup("VariableRemunYear", "qryEntityTexts", "ContractID = " & currentID), "<year>", CStr(rsContracts![contrVariantYear]))
        Else
            .SelectContentControlsByTag("ccIVR").Item(1).Range.Delete
            .SelectContentControlsByTag("ccIVR").Item(1).Delete True
            .SelectContentControlsByTag("ccMAprime").Item(1).Range.Delete
            .SelectContentControlsByTag("ccMAprime").Item(1).Delete True
        End If
        If rsContracts![contrCar] = True Then
            .SelectContentControlsByTag("ccCar").Item(1).Range.Text = DLookup("CompanyCar", "qryEntityTexts", "ContractID = " & currentID)
        Else
            .SelectContentControlsByTag("ccCar").Item(1).Range.Delete
            .SelectContentControlsByTag("ccCar").Item(1).Delete True
        End If
        If rsContracts![contrRepresentCost] = True Then
            .SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text = _
                Replace(.SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text, "<amount>", rsContracts![contrRepresentFixMonthly])
            
            If rsContracts![contrRepresentTelRegime] = 1 Then
                .SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text, "<telephone>", _
                    DLookup("ReprentationFixTel", "qryEntityTexts", "ContractID = " & currentID))
                .SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text, "<bedrag>", rsContracts![contrRepresentTelCost])
            Else
                .SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text = _
                    Replace(.SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Text, "<telephone>", _
                    DLookup("ReprentationUnltdTel", "qryEntityTexts", "ContractID = " & currentID))
            End If
        Else
            .SelectContentControlsByTag("ccRepresentationClause").Item(1).Range.Delete
            .SelectContentControlsByTag("ccRepresentationClause").Item(1).Delete True
        End If
'legally
        If rsContracts![contrWorkPermit] = True Then
            .SelectContentControlsByTag("ccEndWorkPermit").Item(1).Range.Text = DLookup("ContractEnding", "qryEntityTexts", "ContractID = " & currentID)
        Else
            .SelectContentControlsByTag("ccEndWorkPermit").Item(1).Range.Delete
            .SelectContentControlsByTag("ccEndWorkPermit").Item(1).Delete True
        End If
        
        If rsContracts![contrCompetition] = True Then
            .SelectContentControlsByTag("ccCompetition").Item(1).Range.Text = DLookup("Competition", "qryEntityTexts", "ContractID = " & currentID)
        Else
            .SelectContentControlsByTag("ccCompetition").Item(1).Range.Delete
            .SelectContentControlsByTag("ccCompetition").Item(1).Delete True
        End If
        
        If rsContracts![contrNonCompetition] = True Then
            .SelectContentControlsByTag("ccNonCompetition").Item(1).Range.Text = DLookup("NonCompetition", "qryEntityTexts", "ContractID = " & currentID)
        Else
            .SelectContentControlsByTag("ccNonCompetition").Item(1).Range.Delete
            .SelectContentControlsByTag("ccNonCompetition").Item(1).Delete True
        End If

        .SelectContentControlsByTag("ccContractLocation").Item(1).Range.Text = Nz(rsContracts![contrPlace], "Diegem")
        .SelectContentControlsByTag("ccDate").Item(1).Range.Text = Nz(rsContracts![contrCreationDate], Date)
        .SelectContentControlsByTag("ccEntSigner").Item(1).Range.Text = Nz(rsContracts![entSigner], "")
        .SelectContentControlsByTag("ccEmployee2").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
 
 'Footer
 
        .SelectContentControlsByTag("ccFooterEntity").Item(1).Range.Text = Nz(rsContracts![entFooterAddress], "")
        .SelectContentControlsByTag("ccFooterAddress1").Item(1).Range.Text = Nz(rsContracts![entfooterInfo1], "")
        .SelectContentControlsByTag("ccFooterAddress2").Item(1).Range.Text = Nz(rsContracts![entfooterInfo2], "")
        
 'WORD cleanup
        Do While .ContentControls.Count > 0
            For Each objCC In .ContentControls
                objCC.Delete False
            Next
        Loop
        
            With .Content.Find
                .ClearFormatting
                .Replacement.ClearFormatting
                .Text = "^p^p^p"
                .Replacement.Text = "^p^p"
                .Execute Replace:=wdReplaceAll
            End With
        
        'search strings
        heading(1) = "ART: CONCURRENTIE"
        heading(2) = "ART: NIET-CONCURRENTIEBEDING"
        
        For i = 1 To 2
            With .Content.Find
                .ClearFormatting
                .Replacement.ClearFormatting
                .Replacement.Style = .Application.ActiveDocument.Styles("article")
                .Text = heading(i)
                .Replacement.Text = Replace(heading(i), "ART: ", "")
                .Forward = True
                .Format = True
                .Execute Replace:=wdReplaceAll
            End With
       Next i
       
            With .Content.Find
                .ClearFormatting
                .Replacement.ClearFormatting
                .Replacement.Style = .Application.ActiveDocument.Styles("artPoint")
                .Text = "4.x"
                .Replacement.Text = " "
                .Forward = True
                .Format = True
                .Execute Replace:=wdReplaceAll
            End With
     
         End With
   
finalising:
       
        With objWord.ActiveDocument

            .ActiveWindow.View = wdPrintView
            .ActiveWindow.View.Zoom.Percentage = 100
            
            'check if empty folder
            If Dir(contractPath, vbDirectory) & "" = "" Then
                MsgBox "This document will not be saved as there's a problem with the destination folder - please save manually", vbOKOnly, "Destination folder issue"
                GoTo Addend1
            End If
            
            'check if empty doc
            If Dir(contractPathDoc & ".docx") & "" = "" Then
                .SaveAs contractPathDoc, wdFormatDocumentDefault
            Else
                .SaveAs contractPathDoc & "-" & Int(Rnd() * 1000), wdFormatDocumentDefault
            End If
            
            '.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
          
         End With
         Set objWord = Nothing
         
         
'--------------------------------
'Merge processing - Addendum 1
'--------------------------------

Addend1:
'check necessity and set basics
    If Len(templateAdd1) > 0 Then
        templateAdd1 = templatePath & IIf(Right(templatePath, 1) <> "\", "\", "") & templateAdd1
        contractAdd1PathDoc = contractPath & IIf(Right(templatePath, 1) <> "\", "\", "") & "Contract" & Country _
                               & rsContracts![Name] & Year(docDate) & Format(docDate, "mm") & Format(docDate, "dd") & "-Addend1"
    Else
        GoTo Addend2
    End If

'creatre the word doc
    Set objWord = CreateObject("Word.Application")
    With objWord
       .Visible = True
       .Documents.Add (templateAdd1)
    End With
         
'do the merging

       With objWord.ActiveDocument
    
        .SelectContentControlsByTag("ccEntity").Item(1).Range.Text = DLookup("entContractRepresentor", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccEmployee").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccEmployeeLocation").Item(1).Range.Text = Nz(rsContracts![Street], "") & ", " & Nz(rsContracts![PostalCode], "") & " " & _
                                   Nz(rsContracts![City], "") & ", " & Nz(rsContracts![Country], "")
        .SelectContentControlsByTag("ccSalTransfer").Item(1).Range.Text = Nz(rsContracts![contrExpatTransferCost], "")
        .SelectContentControlsByTag("ccSalHousehold").Item(1).Range.Text = Nz(rsContracts![contrExpatHouseholdCost], "")
        .SelectContentControlsByTag("ccSalMoving").Item(1).Range.Text = Nz(rsContracts![contrExpatInstallationCost], "")
        .SelectContentControlsByTag("ccContractLocation").Item(1).Range.Text = Nz(rsContracts![contrPlace], "Diegem")
        .SelectContentControlsByTag("ccDate").Item(1).Range.Text = Nz(rsContracts![contrCreationDate], Date)
        .SelectContentControlsByTag("ccEntSigner").Item(1).Range.Text = Nz(rsContracts![entSigner], "")
        .SelectContentControlsByTag("ccEmployee2").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccFooterEntity").Item(1).Range.Text = Nz(rsContracts![entFooterAddress], "")
        .SelectContentControlsByTag("ccFooterAddress1").Item(1).Range.Text = Nz(rsContracts![entfooterInfo1], "")
        .SelectContentControlsByTag("ccFooterAddress2").Item(1).Range.Text = Nz(rsContracts![entfooterInfo2], "")
'WORD cleanup
        Do While .ContentControls.Count > 0
            For Each objCC In .ContentControls
                objCC.Delete False
            Next
        Loop
'finalising and saving
        .ActiveWindow.View = wdPrintView
        .ActiveWindow.View.Zoom.Percentage = 100
        .SaveAs contractAdd1PathDoc, wdFormatDocumentDefault
        
    End With
    Set objWord = Nothing
         
'--------------------------------
'Merge processing - Addendum 2
'--------------------------------
Addend2:

'check necessity and set basics
    If Len(templateAdd2) > 0 Then
        templateAdd2 = templatePath & IIf(Right(templatePath, 1) <> "\", "\", "") & templateAdd2
        contractAdd2PathDoc = contractPath & IIf(Right(templatePath, 1) <> "\", "\", "") & "Contract" & Country _
                               & rsContracts![Name] & Year(docDate) & Format(docDate, "mm") & Format(docDate, "dd") & "-Addend2"
    Else
        GoTo Addend3
    End If

'creatre the word doc
    Set objWord = CreateObject("Word.Application")
    With objWord
       .Visible = True
       .Documents.Add (templateAdd2)
    End With
         
'do the merging

    With objWord.ActiveDocument
        .SelectContentControlsByTag("ccEntity").Item(1).Range.Text = DLookup("entContractRepresentor", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccEmployee").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccEmployeeLocation").Item(1).Range.Text = Nz(rsContracts![Street], "") & ", " & Nz(rsContracts![PostalCode], "") & " " & _
                                   Nz(rsContracts![City], "") & ", " & Nz(rsContracts![Country], "")
        .SelectContentControlsByTag("ccStartDate").Item(1).Range.Text = Nz(rsContracts![contrFromDate], "")
        .SelectContentControlsByTag("ccContractLocation").Item(1).Range.Text = Nz(rsContracts![contrPlace], "Diegem")
        .SelectContentControlsByTag("ccDate").Item(1).Range.Text = Nz(rsContracts![contrCreationDate], Date)
        .SelectContentControlsByTag("ccEntSigner").Item(1).Range.Text = Nz(rsContracts![entSigner], "")
        .SelectContentControlsByTag("ccEmployee2").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccFooterEntity").Item(1).Range.Text = Nz(rsContracts![entFooterAddress], "")
        .SelectContentControlsByTag("ccFooterAddress1").Item(1).Range.Text = Nz(rsContracts![entfooterInfo1], "")
        .SelectContentControlsByTag("ccFooterAddress2").Item(1).Range.Text = Nz(rsContracts![entfooterInfo2], "")
'WORD cleanup
        Do While .ContentControls.Count > 0
            For Each objCC In .ContentControls
                objCC.Delete False
            Next
        Loop
'finalising and saving
        .ActiveWindow.View = wdPrintView
        .ActiveWindow.View.Zoom.Percentage = 100
        .SaveAs contractAdd2PathDoc, wdFormatDocumentDefault
        
    End With
    Set objWord = Nothing
         
'--------------------------------
'Merge processing - Addendum 3
'--------------------------------
Addend3:

'check necessity and set basics
    If Len(templateAdd3) > 0 Then
        templateAdd3 = templatePath & IIf(Right(templatePath, 1) <> "\", "\", "") & templateAdd3
        contractAdd3PathDoc = contractPath & IIf(Right(templatePath, 1) <> "\", "\", "") & "Contract" & Country _
                               & rsContracts![Name] & Year(docDate) & Format(docDate, "mm") & Format(docDate, "dd") & "-Addend3"
    Else
        GoTo Addend4
    End If

'creatre the word doc
    Set objWord = CreateObject("Word.Application")
    With objWord
       .Visible = True
       .Documents.Add (templateAdd3)
    End With
         
'do the merging

    With objWord.ActiveDocument
        .SelectContentControlsByTag("ccEntity").Item(1).Range.Text = DLookup("entContractRepresentor", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccEmployee").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccEmployeeLocation").Item(1).Range.Text = Nz(rsContracts![Street], "") & ", " & Nz(rsContracts![PostalCode], "") & " " & _
                                   Nz(rsContracts![City], "") & ", " & Nz(rsContracts![Country], "")
        .SelectContentControlsByTag("ccSector").Item(1).Range.Text = Nz(rsContracts![contrMAsector], "")
        .SelectContentControlsByTag("ccContractLocation").Item(1).Range.Text = Nz(rsContracts![contrPlace], "Diegem")
        .SelectContentControlsByTag("ccDate").Item(1).Range.Text = Nz(rsContracts![contrCreationDate], Date)
        .SelectContentControlsByTag("ccEntSigner").Item(1).Range.Text = Nz(rsContracts![entSigner], "")
        .SelectContentControlsByTag("ccEmployee2").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccFooterEntity").Item(1).Range.Text = Nz(rsContracts![entFooterAddress], "")
        .SelectContentControlsByTag("ccFooterAddress1").Item(1).Range.Text = Nz(rsContracts![entfooterInfo1], "")
        .SelectContentControlsByTag("ccFooterAddress2").Item(1).Range.Text = Nz(rsContracts![entfooterInfo2], "")
'WORD cleanup
        Do While .ContentControls.Count > 0
            For Each objCC In .ContentControls
                objCC.Delete False
            Next
        Loop
'finalising and saving
        .ActiveWindow.View = wdPrintView
        .ActiveWindow.View.Zoom.Percentage = 100
        .SaveAs contractAdd3PathDoc, wdFormatDocumentDefault
        
    End With
    Set objWord = Nothing
         
'--------------------------------
'Merge processing - Addendum 4
'--------------------------------
Addend4:

'check necessity and set basics
    If Len(templateAdd4) > 0 Then
        templateAdd4 = templatePath & IIf(Right(templatePath, 1) <> "\", "\", "") & templateAdd4
        contractAdd4PathDoc = contractPath & IIf(Right(templatePath, 1) <> "\", "\", "") & "Contract" & Country _
                               & rsContracts![Name] & Year(docDate) & Format(docDate, "mm") & Format(docDate, "dd") & "-Addend4"
    Else
        GoTo mergeToPdf
    End If

'creatre the word doc
    Set objWord = CreateObject("Word.Application")
    With objWord
       .Visible = True
       .Documents.Add (templateAdd4)
    End With
         
'do the merging

    With objWord.ActiveDocument
        .SelectContentControlsByTag("ccEntity").Item(1).Range.Text = DLookup("entContractRepresentor", "qryEntityTexts", "ContractID = " & currentID)
        .SelectContentControlsByTag("ccEmployee").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccEmployeeLocation").Item(1).Range.Text = Nz(rsContracts![Street], "") & ", " & Nz(rsContracts![PostalCode], "") & " " & _
                                   Nz(rsContracts![City], "") & ", " & Nz(rsContracts![Country], "")

        .SelectContentControlsByTag("ccContractLocation").Item(1).Range.Text = Nz(rsContracts![contrPlace], "Diegem")
        .SelectContentControlsByTag("ccDate").Item(1).Range.Text = Nz(rsContracts![contrCreationDate], Date)
        .SelectContentControlsByTag("ccEntSigner").Item(1).Range.Text = Nz(rsContracts![entSigner], "")
        .SelectContentControlsByTag("ccEmployee2").Item(1).Range.Text = Nz(rsContracts![FirstName], "") & " " & Nz(rsContracts![Name], "")
        .SelectContentControlsByTag("ccFooterEntity").Item(1).Range.Text = Nz(rsContracts![entFooterAddress], "")
        .SelectContentControlsByTag("ccFooterAddress1").Item(1).Range.Text = Nz(rsContracts![entfooterInfo1], "")
        .SelectContentControlsByTag("ccFooterAddress2").Item(1).Range.Text = Nz(rsContracts![entfooterInfo2], "")
'WORD cleanup
        Do While .ContentControls.Count > 0
            For Each objCC In .ContentControls
                objCC.Delete False
            Next
        Loop
'finalising and saving
        .ActiveWindow.View = wdPrintView
        .ActiveWindow.View.Zoom.Percentage = 100
        .SaveAs contractAdd4PathDoc, wdFormatDocumentDefault
        
    End With
    Set objWord = Nothing


mergeToPdf:
'--------------------------------
'Merging to pdf
'--------------------------------
    answer = MsgBox("The contract (and addendums) has been succesfully generated " & vbNewLine & _
                "Do you want to merge all in one document?", vbYesNo, "Contract generated")
 
    If answer = vbNo Then
        GoTo closing
    End If
    
    templateEmpty = templatePath & IIf(Right(templatePath, 1) <> "\", "\", "") & templateEmpty
    
    Set objWord = CreateObject("Word.Application")
    With objWord
       .Visible = True
       .Documents.Add (templateEmpty)
    End With
    
    'strFile = Dir$(contractPath & contractDoc & "*.docx")
    strFile = Array(contractPathDoc, contractAdd1PathDoc, contractAdd2PathDoc, contractAdd3PathDoc, contractAdd4PathDoc)
    'Count = 0
    'Do Until strFile = ""
    For Count = 0 To UBound(strFile)
        'Count = Count + 1
        Set rng = objWord.ActiveDocument.Range
        With rng
            .Collapse wdCollapseEnd
            If Count > 0 And strFile(Count) <> "" Then
                .InsertBreak wdSectionBreakNextPage
                .End = objWord.ActiveDocument.Range.End
                .Collapse wdCollapseEnd
            End If
            If strFile(Count) <> "" Then
                .InsertFile strFile(Count) & ".docx"
            End If
        End With
        'strFile = Dir$()
    'Loop
    Next
    
    With objWord.ActiveDocument
        .ActiveWindow.View = wdPrintView
        .ActiveWindow.View.Zoom.Percentage = 100
        .SaveAs contractPathDoc & "-All", wdFormatDocumentDefault
        If Dir(contractPathDoc & "-All.pdf") <> vbNullString Then
            Kill contractPathDoc & "-All.pdf"
        End If
        .SaveAs contractPathDoc & "-All.pdf", 17
    End With
    
    MsgBox "Contract files have been merged into one master document"


closing:
        
        Application.Echo True
        DoCmd.Hourglass False
        DoCmd.SetWarnings True
  
        Exit Sub
        
errorHandling:
        If Err.Number = 91 Or Err.Number = 4198 Or Err.Number = 4248 Then Exit Sub  'doc is open or not avail
        'MsgBox "An error occurred : " & Err.Description & " - " & Err.Number
        'Resume Next
        GoTo closing:
        
End Sub

Sub ResetFRParameters(oRng As Range)
  With oRng.Find
    .ClearFormatting
    .Replacement.ClearFormatting
    .Text = ""
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = False
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
    .Execute
  End With
End Sub


'Function FnEnumerateAllWordDoc()
'
'   Set objWord = GetObject(, "Word.Application")
'
'   objWord.Visible = True
'
'   For Each objDoc In objWord.Documents
'
'      MsgBox "Name: " & objDoc.Name & " And " & objDoc.Path
'
'   Next
'
'End Function
