Attribute VB_Name = "SalaryExportExcel"
Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" ( _
ByVal pCaller As Long, ByVal szURL As String, _
ByVal szFileName As String, _
ByVal dwReserved As Long, _
ByVal lpfnCB As Long) As Long


Option Compare Database
Option Explicit

Public Sub SalaryOutputToExcel(strType As String)
' Function to load selected data into an Excelsheet

Dim objXLApp As Object, objXLws As Object
Dim db As DAO.Database, rst As DAO.Recordset
Dim strDoc, strDocPath, strExportDoc, strExportPath, strName As String
Dim tdf As DAO.TableDef
    
    ' error handling
    On Error GoTo errHandling
    
    ' remove warnings if applicable
    DoCmd.SetWarnings False
    
    ' empty current table & run the base query
    DoCmd.OpenQuery "qdelSalaryPackage", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageGeneral", acViewNormal
        
    ' Check if there is result before going on
    'Set db = CurrentDb
    Set db = DBEngine(0)(0)
    ' Open a recordset on the query for the data to export
    ' Data loaded by code in frmReports to the tvwRptCaseDetails table
    'Set rst = db.OpenRecordset("Select * From [qrySalaryPackageToExcel] where MISS_ID = " & Forms![F_MISSION__NEW_ALLSTATUS]![MISS_ID])
    Set rst = db.OpenRecordset("T_Z_SalaryPackage")
    'Set rst = db.TableDefs("qrySalaryPackageToExcel")
    ' If there are no records, return an error and exit function
    If rst.EOF Then
        MsgBox "You cannot create a package for a mission with Inactive/Returned status and/or inappropriate ID."
        rst.Close
        Set rst = Nothing
        Set db = Nothing
        Exit Sub
    End If
    
    'Execute the queries to populate the export table
    DoCmd.OpenQuery "qappSalaryPackageCat", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageChildren", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageChildrenBirthdates", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageExpatPol", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageFamSit", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageHL", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageHLmission", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackagePartner", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackagePension", acViewNormal
    DoCmd.OpenQuery "qrySalaryPackageStatus", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageOffshorePay", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSocSec", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryMonth100Current", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryMonthBaseY", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryMonthBaseY-1", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryAnnualGrossCurrent", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryAnnualGrossY", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryAnnualGrossY-1", acViewNormal
    'DoCmd.OpenQuery "qappSalaryPackageSalaryAnnual100Current", acViewNormal
    DoCmd.OpenQuery "qappSalaryPackageSalaryMonthGrossCurrent", acViewNormal
    
    DoCmd.OpenQuery "qupdBirthDaysSerial", acViewNormal
    
    
    
   
    ' Determine the paths and names to the template and the saved Excel doc
    If Not IsNull(Forms![F_MISSION__NEW_ALLSTATUS]![cmbSalaryPack].Column(1)) Then
         strDoc = Forms![F_MISSION__NEW_ALLSTATUS]![cmbSalaryPack].Column(1)
    Else
        MsgBox "Problem occurred, procedure will be terminated"
        Exit Sub
    End If
    
    strName = Forms![F_MISSION__NEW_ALLSTATUS]![MISS_EXPAT_ID].Column(1)
    strDocPath = DLookup("Path", "T_Z_Paths", "PathID = " & "'" & "Templates" & "'")
    strExportPath = DLookup("Path", "T_Z_Paths", "PathID = " & "'" & "Exports" & "'")
    strExportDoc = strExportPath & strName & "_" & Year(Date) & Month(Date) & Day(Date) & Hour(Time) & Minute(Time) & "_" & strDoc
    strDoc = strDocPath & strDoc
    
    Debug.Print strDoc
    
    ' If the file we want to build already exists
    If Dir(strExportDoc) <> "" Then
        ' Delete it
        Kill strExportDoc
    End If


    ' This might take a while, turn on the hourglass
    DoCmd.Hourglass True
    Status ("Running the queries and preparing the export... please wait")
    
    ' Populate the excel object
    Set objXLApp = CreateObject("Excel.Application")
    ' Open the template workbook
    objXLApp.Workbooks.Open (strDoc)
    ' Save the template as the file specified by the user
    objXLApp.ActiveWorkbook.SaveAs (strExportDoc)
    ' Select the 'iExpatData' worksheet
    Set objXLws = objXLApp.ActiveWorkbook.Worksheets("iExpatDB")
    'make it unhidden
    objXLws.Visible = True
    ' Activate the selected worksheet
    objXLws.Activate
    ' Ask Excel to copy the data from the recordset
    objXLws.Range("A2").CopyFromRecordset rst
    'make it hidden
    objXLws.Visible = False
    ' Select the ExpatData worksheet
    objXLApp.Worksheets("ExpatData").Activate
    ' Activate the selected worksheet
    
    MsgBox "Data available at " & strExportPath, , "Export ok"

    
    ' Destroy the recordset and database objects
    rst.Close
    Set rst = Nothing
    Set db = Nothing
    
    ' Hide warnings on the spreadsheet
    objXLApp.DisplayAlerts = False
    ' Save the workbook
    objXLApp.ActiveWorkbook.Save
    ' Turn spreadsheet warnings back on
    objXLApp.DisplayAlerts = True
    ' Make it visible
    objXLApp.Visible = True
    'objXLApp.ActiveWorkbook.Close
    
Closing:
    ' Turn the hourglass off
    DoCmd.Hourglass False
    DoCmd.SetWarnings True
    Status ("")
    
    ' Reset variables
    Set objXLws = Nothing
    Set objXLApp = Nothing
    Exit Sub

errHandling:
    MsgBox Err.Description & " - error Nr:" & Err.Number
    Exit Sub
    
End Sub


Sub DownloadFileFromWeb()
Dim i As Integer

Const strUrl As String = "http://www.2013.net/courses/excel/pharma.xls"
Dim strSavePath As String
Dim returnValue As Long

 strSavePath = "D:\Data\Clients\LVDD\iExpat\SalaryPackages\xxxx.xls"
 returnValue = URLDownloadToFile(0, strUrl, strSavePath, 0, 0)

End Sub


'Excel code
'Sub uploadToWeb()
'Dim WScript, FileSystemObject
'Dim WshNetwork
'Set WshNetwork = WScript.CreateObject("WScript.Network")
'WshNetwork.MapNetworkDrive "Z:", "\\VORTEX\Data\Clients\LVDD\iExpat\SalaryPackages"
''fso = new ActiveXObject("Scripting.FileSystemObject")
''fso.CopyFile "D:\Data\Clients\LVDD\iExpat\Templates\BEI_Salary Package.xls", "Z:\\"
'FileSystemObject.CopyFile "D:\Data\Clients\LVDD\iExpat\Templates\BEI_Salary Package.xls", "Z:\"
'
'End Sub


Sub Status(txtStatus As String)
    
    Dim lvarStatus As Variant
    
    If txtStatus = "" Then
        lvarStatus = SysCmd(acSysCmdClearStatus)
    Else
        lvarStatus = SysCmd(acSysCmdSetStatus, txtStatus)
    End If
    
End Sub


